package cn.hynoo.nativecanvas.test;

import org.json.JSONException;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.KeyEvent;
import cn.hynoo.nativecanvas.NativeCanvasView;
import cn.hynoo.nativecanvas.plugin.PluginManager;
import cn.hynoo.nativecanvas.plugin.PluginManager.PluginHandler;

public class MainActivity extends Activity {

	private NativeCanvasView canvasView;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		//setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		
		// create native canvas view
		createCanvasView();
		
		// register native handlers
		registerPluginHandlers();
	}
	
	private void createCanvasView() {
		
		canvasView = new NativeCanvasView(this);
		
		canvasView.setListener(new NativeCanvasView.Listener() {
			
			@Override
			public void onLoadComplete() {
				// load index html
				canvasView.load("file:///android_asset/www/index.html");
			}
		});		
		
		setContentView(canvasView);
	}

	@Override
	public void onResume() {
		super.onResume();
		
		if (canvasView != null) {
			canvasView.onResume();
		}
	}

	@Override
	public void onPause() {
		if (canvasView != null) {
			canvasView.onPause();
		}
		super.onPause();
	}
	
	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		if (canvasView != null)
			return canvasView.handleKeyEvent(event);
		else
			return false;
	}
	
	private void registerPluginHandlers() {

		// for window.close() calling from javascript
		PluginManager.registerPluginHandler("app.exit", new PluginHandler(){
			@Override
			public void action(String params, int sessionId) throws JSONException {
				PluginManager.nativeResponse(sessionId);

				runOnUiThread(new Runnable() {
					@Override
					public void run() {
						canvasView.onDestroy();
						finish();
						System.exit(0);					
					}
				});
			}
		});

	}

}